"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cssnano_1 = __importDefault(require("cssnano"));
var Loader_1 = __importDefault(require("./Loader"));
var useIf_1 = __importDefault(require("../helpers/useIf"));
var autoprefixer_1 = __importDefault(require("autoprefixer"));
var mini_css_extract_plugin_1 = __importDefault(require("mini-css-extract-plugin"));
var Sass = (function (_super) {
    __extends(Sass, _super);
    function Sass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Sass.prototype.register = function () {
        this.createCSSRule("css", /\.css$/);
        this.createCSSRule("sass", /\.s[ac]ss$/, "sass-loader", {
            sourceMap: true,
            implementation: require("node-sass"),
        });
        if (!this.bundler.env.isHot) {
            this.bundler.webpackChain
                .plugin("mini-extract")
                .use(mini_css_extract_plugin_1.default, [
                {
                    filename: "css/[name]-[" + this.options.hashType + "].css",
                    chunkFilename: "css/[name]-[" + this.options.hashType + "].css",
                },
            ]);
        }
    };
    Sass.prototype.createCSSRule = function (lang, test, loader, loaderOptions) {
        if (loaderOptions === void 0) { loaderOptions = {}; }
        var baseRule = this.bundler.webpackChain.module.rule(lang).test(test);
        this.applyLoaders(baseRule.oneOf("vue").resourceQuery(/\?vue/), loader, loaderOptions);
        this.applyLoaders(baseRule.oneOf("normal"), loader, loaderOptions);
    };
    Sass.prototype.applyLoaders = function (oneOf, loader, loaderOptions) {
        if (loaderOptions === void 0) { loaderOptions = {}; }
        oneOf
            .when(!this.bundler.env.isHot, function (config) {
            config
                .use("mini-extract-loader")
                .loader(mini_css_extract_plugin_1.default.loader)
                .end();
        }, function (config) {
            config
                .use("vue-style-loader")
                .loader("vue-style-loader")
                .options({
                sourceMap: true,
            })
                .end();
        })
            .use("css-loader")
            .loader("css-loader")
            .options({
            sourceMap: !this.bundler.env.isProduction,
            importLoaders: loader ? 3 : 2,
        })
            .end()
            .use("postcss-loader")
            .loader("postcss-loader")
            .options({
            postcssOptions: {
                sourceMap: true,
                ident: "postcss",
                plugins: __spreadArray([
                    (0, autoprefixer_1.default)({ grid: true })
                ], (0, useIf_1.default)(!this.bundler.env.isHot, [cssnano_1.default]), true),
            }
        })
            .end()
            .use("resolve-url-loader")
            .loader("resolve-url-loader")
            .options({
            sourceMap: true,
        })
            .end();
        if (loader) {
            oneOf
                .use(loader)
                .loader(loader)
                .options(loaderOptions);
        }
    };
    return Sass;
}(Loader_1.default));
exports.default = Sass;
//# sourceMappingURL=Sass.js.map